
function output = layer_creator(T, n_clusters, cluster_dim, cluster_mat, layer_mat, decay, noise, cluster_bl)

baseline=-70;                 %baseline per layer
threshold=baseline+15;        %activation threashold per layer

for i=1:n_clusters
    
layer.potential{i} = ones(T,cluster_dim)*(baseline);
layer.activity{i}  = ones(T,cluster_dim)*0;
for t=2:T
    layer.potential{i}(t,:)= baseline + (rand(1,cluster_dim)<cluster_bl)*15;
    if t>7
        for ii=1:cluster_dim
            if sum(layer.activity{i}((t-6):(t-1),ii))>0
                layer.potential{i}(t,ii)=baseline;
            end
        end
    end
end
end

layer.decay=decay;
layer.baseline=baseline;
layer.th_out=threshold;
layer.noise_switch=noise;


%matrix for inter-layer connections
layer.self_mat=mat_creator(n_clusters, n_clusters, cluster_dim, cluster_dim, layer_mat.perc_conn, ...
                           layer_mat.perc_GABA, layer_mat.str_conn);

%matrix for the cluster connections
mat_cluster = mat_creator(n_clusters, 1, cluster_dim, cluster_dim, cluster_mat.perc_conn, ...
                                    cluster_mat.perc_GABA, cluster_mat.str_conn);
for ind=1:n_clusters
    layer.self_mat{ind,ind}=mat_cluster{ind,ind};
end

if sum(sum(layer.self_mat{1,1}))==0
    error ('error: lack of connections within clusters. Specified units would be isolated.');
end
      
output = layer;