
function output = layer_step(t, dt, layer, input1, connectivity1, input2, connectivity2, input3, connectivity3)

dim_cluster=length(layer.activity{1}(t,:));
n_cluster=length(layer.activity);

for i=1:n_cluster

    mod_baseline=layer.baseline + ((rand(1, dim_cluster)*20)-10) .*layer.noise_switch;
    
    self_input=0;
    for ic=1:n_cluster
        self_input=self_input+layer.activity{ic}(t-1,:)*layer.self_mat{ic,i};
    end
    
    inp1=0;
    inp2=0;
    inp3=0;
    if isfield(input1,'activity')==1         
        for ic=1:length(connectivity1(:,1))
            inp1=inp1+input1.activity{ic}(t-1,:)*connectivity1{ic,i};
        end
    end
    if isfield(input2,'activity')==1 
        for ic=1:length(connectivity2(:,1))
            inp2=inp2+input2.activity{ic}(t-1,:)*connectivity2{ic,i};
        end
    end
    if isfield(input3,'activity')==1 
        for ic=1:length(connectivity3(:,1))
            inp3=inp3+input3.activity{ic}(t-1,:)*connectivity3{ic,i};
        end
    end
    
    % ACTION POTENTIAL
    layer.potential{i}(t,:) = layer.potential{i}(t,:) + (dt./layer.decay).*(-layer.potential{i}(t-1,:) + mod_baseline +...
                              self_input + inp1 + inp2 + inp3);
      
    %this control avoids biologically implausible hyperpolarizations
    hyper_th=-80;
    layer.potential{i}(t,:) = max ( hyper_th, layer.potential{i}(t,:));
    
    % This control avoids firing during the refractary period
    for in=1:dim_cluster    
        if t>6 && sum(layer.activity{i}(t-6:t,in))>=1
            layer.potential{i}(t,in) = -70;
            %disp ('Check')
        end
    end

    %transfer function
    layer.activity{i}(t,:) = 40*(layer.potential{i}(t,:)>layer.th_out);
end

output = layer;